Index: src/xplcommon/win32/BufferedStream.h
===================================================================
--- src/xplcommon/win32/BufferedStream.h	(revision 21)
+++ src/xplcommon/win32/BufferedStream.h	(revision 21)
@@ -0,0 +1,153 @@
+// Copyright (c) 2012 by István Váradi
+
+// This file is part of libxplcommon, a common utility library for
+// development related to X-Plane
+
+// Redistribution and use in source and binary forms, with or without
+// modification, are permitted provided that the following conditions are met:
+
+// 1. Redistributions of source code must retain the above copyright notice, this
+//    list of conditions and the following disclaimer.
+// 2. Redistributions in binary form must reproduce the above copyright notice,
+//    this list of conditions and the following disclaimer in the documentation
+//    and/or other materials provided with the distribution.
+
+// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
+// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+// DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
+// ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+// LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+// ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+// The views and conclusions contained in the software and documentation are those
+// of the authors and should not be interpreted as representing official policies,
+// either expressed or implied, of the FreeBSD Project.
+
+#ifndef XPLCOMMON_WIN32_BUFFEREDSTREAM_H
+#define XPLCOMMON_WIN32_BUFFEREDSTREAM_H
+//------------------------------------------------------------------------------
+
+#include "Overlappable.h"
+
+//------------------------------------------------------------------------------
+
+namespace xplcommon { namespace win32 {
+
+//------------------------------------------------------------------------------
+
+class ReadingBuffer;
+class WritingBuffer;
+class Overlapped;
+
+//------------------------------------------------------------------------------
+
+/**
+ * A buffered stream.
+ *
+ * It wraps a HANDLE which can be read and/or written with ReadFile or
+ * WriteFile, respectively.
+ */
+class BufferedStream : public Overlappable
+{
+public:
+    /**
+     * The default capacity.
+     */
+    static const size_t DEFAULT_CAPACITY = 4096;
+
+private:
+    /**
+     * The reading buffer. It may be 0, if no reading buffer is
+     * associated with this waitable.
+     */
+    ReadingBuffer* readingBuffer;
+
+    /**
+     * The writing buffer. It may be 0, if no writing buffer is
+     * associated with this waitable.
+     */
+    WritingBuffer* writingBuffer;
+
+protected:
+    /**
+     * Construct the buffered stream.
+     */
+    BufferedStream(Waiter* waiter = 0, HANDLE handle = 0,
+                   size_t readingCapacity = DEFAULT_CAPACITY,
+                   size_t writingCapacity = DEFAULT_CAPACITY);
+
+public:
+    /**
+     * Destroy the stream.
+     */
+    virtual ~BufferedStream();
+
+    /**
+     * Get the reference of the reading buffer. Note, that it can be a
+     * 0 reference, if the stream has no reading buffer.
+     */
+    ReadingBuffer& getReadingBuffer();
+
+    /**
+     * Get the reference of the writing buffer. Note, that it can be a
+     * 0 reference, if the stream has no writing buffer.
+     */
+    WritingBuffer& getWritingBuffer();
+
+protected:
+    /**
+     * Read using the handle at most the given number of bytes into
+     * the given buffer.
+     *
+     * @return the number of bytes read. If 0, it indicates the end of
+     * the file or connection. If negative, it means either a failure,
+     * or the fact that the operation cannot be completed at this time.
+     */
+    ssize_t read(void* dest, size_t length, Overlapped* overlapped);
+
+    /**
+     * Write using the handle the given number of bytes from the given
+     * buffer.
+     *
+     * @return whether the writing succeeded. If false, it is either a
+     * failure, or an inidication of the fact that the operation could
+     * not be completed.
+     */
+    bool write(const void* src, size_t length, Overlapped* overlapped);
+
+    friend class ReadingBuffer;
+    friend class WritingBuffer;
+};
+
+//------------------------------------------------------------------------------
+// Inline definitions
+//------------------------------------------------------------------------------
+
+inline ReadingBuffer& BufferedStream::getReadingBuffer()
+{
+    return *readingBuffer;
+}
+
+//------------------------------------------------------------------------------
+
+inline WritingBuffer& BufferedStream::getWritingBuffer()
+{
+    return *writingBuffer;
+}
+
+//------------------------------------------------------------------------------
+
+} /* namespace xplcommon::win32 */ } /* namespace xplcommon */
+
+//------------------------------------------------------------------------------
+#endif // XPLCOMMON_WIN32_BUFFEREDSTREAM_H
+
+// Local Variables:
+// mode: C++
+// c-basic-offset: 4
+// indent-tabs-mode: nil
+// End:
Index: src/xplcommon/win32/Completer.h
===================================================================
--- src/xplcommon/win32/Completer.h	(revision 21)
+++ src/xplcommon/win32/Completer.h	(revision 21)
@@ -0,0 +1,148 @@
+// Copyright (c) 2012 by István Váradi
+
+// This file is part of libxplcommon, a common utility library for
+// development related to X-Plane
+
+// Redistribution and use in source and binary forms, with or without
+// modification, are permitted provided that the following conditions are met:
+
+// 1. Redistributions of source code must retain the above copyright notice, this
+//    list of conditions and the following disclaimer.
+// 2. Redistributions in binary form must reproduce the above copyright notice,
+//    this list of conditions and the following disclaimer in the documentation
+//    and/or other materials provided with the distribution.
+
+// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
+// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+// DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
+// ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+// LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+// ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+// The views and conclusions contained in the software and documentation are those
+// of the authors and should not be interpreted as representing official policies,
+// either expressed or implied, of the FreeBSD Project.
+
+#ifndef XPLCOMMON_WIN32_COMPLETER_H
+#define XPLCOMMON_WIN32_COMPLETER_H
+//------------------------------------------------------------------------------
+
+#include "Overlapped.h"
+#include "Overlappable.h"
+
+//------------------------------------------------------------------------------
+
+namespace xplcommon { namespace win32 {
+
+//------------------------------------------------------------------------------
+
+/**
+ * Base class for objects that handle the completion of some
+ * operation. They are associated with an Overlappable, and if that
+ * overlappable is non-blocking (i.e. has a waiter), an Overlapped
+ * object is created and stored in this object.
+ */
+class Completer
+{
+protected:
+    /**
+     * The overlapped object.
+     */
+    Overlapped* overlapped;
+
+protected:
+    /**
+     * Construct the completer for the given Overlappable.
+     */
+    Completer(Overlappable* overlappable);
+
+    /**
+     * Destroy the completer.
+     */
+    ~Completer();
+
+    /**
+     * Add the overlapped object (if any) to the given waiter.
+     */
+    void addTo(Waiter* waiter);
+
+    /**
+     * Remove the overlapped object (if any) from the waiter it is
+     * associated with.
+     */
+    void removeFromWaiter();
+
+    /**
+     * Determine if there is an overlapped object and it is being
+     * waited for.
+     */
+    bool isWaited() const;
+
+    /**
+     * Get the result of the overlapped operation, if any.
+     *
+     * @see Overlapped::getResult
+     */
+    bool getResult(DWORD& size, HANDLE file);
+};
+
+//------------------------------------------------------------------------------
+// Inline definitions
+//------------------------------------------------------------------------------
+
+inline Completer::Completer(Overlappable* overlappable) :
+    overlapped((overlappable->waiter==0) ? 0 : new Overlapped(*overlappable))
+{
+}
+
+//------------------------------------------------------------------------------
+
+inline Completer::~Completer()
+{
+    delete overlapped;
+}
+
+//------------------------------------------------------------------------------
+
+inline void Completer::addTo(Waiter* waiter)
+{
+    if (overlapped!=0 && waiter!=0) overlapped->addTo(*waiter);
+}
+
+//------------------------------------------------------------------------------
+
+inline void Completer::removeFromWaiter()
+{
+    if (overlapped!=0) overlapped->removeFromWaiter();
+}
+
+//------------------------------------------------------------------------------
+
+inline bool Completer::isWaited() const
+{
+    return overlapped!=0 && overlapped->isWaited();
+}
+
+//------------------------------------------------------------------------------
+
+inline bool Completer::getResult(DWORD& size, HANDLE file)
+{
+    return overlapped!=0 && overlapped->getResult(size, file);
+}
+
+//------------------------------------------------------------------------------
+
+} /* namespace xplcommon::win32 */ } /* namespace xplcommon */
+
+//------------------------------------------------------------------------------
+#endif // XPLCOMMON_WIN32_COMPLETER_H
+
+// Local Variables:
+// mode: C++
+// c-basic-offset: 4
+// indent-tabs-mode: nil
+// End:
Index: src/xplcommon/win32/Event.cc
===================================================================
--- src/xplcommon/win32/Event.cc	(revision 20)
+++ src/xplcommon/win32/Event.cc	(revision 21)
@@ -40,4 +40,19 @@
 //------------------------------------------------------------------------------
 
+bool Event::isFired() const
+{
+    DWORD result = WaitForSingleObject(handle, (waiter==0) ? INFINITE : 0);
+    if (result==WAIT_FAILED) {
+        eventFailable.setErrorCode(GetLastError());
+        return false;
+    } else if (result==WAIT_OBJECT_0) {
+        return true;
+    } else {
+        return false;
+    }
+}
+
+//------------------------------------------------------------------------------
+
 void Event::addTo(Waiter& w)
 {
Index: src/xplcommon/win32/Event.h
===================================================================
--- src/xplcommon/win32/Event.h	(revision 20)
+++ src/xplcommon/win32/Event.h	(revision 21)
@@ -32,5 +32,5 @@
 //------------------------------------------------------------------------------
 
-#include "../Failable.h"
+#include "EventFailable.h"
 
 #include <windows.h>
@@ -49,8 +49,13 @@
  * Wrapper for an event.
  */
-class Event : public ::xplcommon::Failable
+class Event
 {
 private:
     /**
+     * The object receiving the failure codes.
+     */
+    EventFailable& eventFailable;
+
+    /**
      * The handle of the event.
      */
@@ -66,5 +71,5 @@
      * Construct the event.
      */
-    Event();
+    Event(EventFailable& eventFailable);
 
     /**
@@ -96,7 +101,18 @@
 
     /**
+     * Determine if the event is being waited for, i.e. it is
+     * associated with a waiter.
+     */
+    bool isWaited() const;
+
+    /**
      * Set the event.
      */
     void fire();
+
+    /**
+     * Determine if the event is fired or not.
+     */
+    bool isFired() const;
 
     /**
@@ -106,4 +122,10 @@
      */
     bool clear();
+
+protected:
+    /**
+     * Set the error code on the failable object.
+     */
+    void setErrorCode(errorCode_t errorCode);
 };
 
@@ -112,9 +134,10 @@
 //------------------------------------------------------------------------------
 
-inline Event::Event() :
+inline Event::Event(EventFailable& eventFailable) :
+    eventFailable(eventFailable),
     handle(CreateEvent(0, true, false, 0)),
     waiter(0)
 {
-    if (handle==0) setErrorCode(GetLastError());
+    if (handle==0) eventFailable.setErrorCode(GetLastError());
 }
 
@@ -143,8 +166,15 @@
 //------------------------------------------------------------------------------
 
+inline bool Event::isWaited() const
+{
+    return waiter!=0;
+}
+
+//------------------------------------------------------------------------------
+
 inline void Event::fire()
 {
     if (!SetEvent(handle)) {
-        setErrorCode(GetLastError());
+        eventFailable.setErrorCode(GetLastError());
     }
 }
@@ -155,9 +185,16 @@
 {
     if (!ResetEvent(handle)) {
-        setErrorCode(GetLastError());
+        eventFailable.setErrorCode(GetLastError());
         return false;
     } else {
         return true;
     }
+}
+
+//------------------------------------------------------------------------------
+
+inline void Event::setErrorCode(errorCode_t errorCode)
+{
+    eventFailable.setErrorCode(errorCode);
 }
 
Index: src/xplcommon/win32/EventFailable.h
===================================================================
--- src/xplcommon/win32/EventFailable.h	(revision 21)
+++ src/xplcommon/win32/EventFailable.h	(revision 21)
@@ -0,0 +1,68 @@
+// Copyright (c) 2012 by István Váradi
+
+// This file is part of libxplcommon, a common utility library for
+// development related to X-Plane
+
+// Redistribution and use in source and binary forms, with or without
+// modification, are permitted provided that the following conditions are met:
+
+// 1. Redistributions of source code must retain the above copyright notice, this
+//    list of conditions and the following disclaimer.
+// 2. Redistributions in binary form must reproduce the above copyright notice,
+//    this list of conditions and the following disclaimer in the documentation
+//    and/or other materials provided with the distribution.
+
+// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
+// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+// DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
+// ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+// LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+// ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+// The views and conclusions contained in the software and documentation are those
+// of the authors and should not be interpreted as representing official policies,
+// either expressed or implied, of the FreeBSD Project.
+
+#ifndef XPLCOMMON_WIN32_EVENTFAILABLE_H
+#define XPLCOMMON_WIN32_EVENTFAILABLE_H
+//------------------------------------------------------------------------------
+
+#include "../Failable.h"
+
+//------------------------------------------------------------------------------
+
+namespace xplcommon { namespace win32 {
+
+//------------------------------------------------------------------------------
+
+class Event;
+
+//------------------------------------------------------------------------------
+
+/**
+ * A special subclass of Failable, the instances of which can be given
+ * as a Failable target object to events. If some operation on an
+ * event fails, the error code will be set on such an instance,
+ * associated with the event.
+ */
+class EventFailable : public ::xplcommon::Failable
+{
+    friend class Event;
+};
+
+//------------------------------------------------------------------------------
+
+} /* namespace xplcommon::win32 */ } /* namespace xplcommon */
+
+//------------------------------------------------------------------------------
+#endif // XPLCOMMON_WIN32_EVENTFAILABLE_H
+
+// Local Variables:
+// mode: C++
+// c-basic-offset: 4
+// indent-tabs-mode: nil
+// End:
Index: src/xplcommon/win32/LocalAcceptor.cc
===================================================================
--- src/xplcommon/win32/LocalAcceptor.cc	(revision 21)
+++ src/xplcommon/win32/LocalAcceptor.cc	(revision 21)
@@ -0,0 +1,89 @@
+// Copyright (c) 2012 by István Váradi
+
+// This file is part of libxplcommon, a common utility library for
+// development related to X-Plane
+
+// Redistribution and use in source and binary forms, with or without
+// modification, are permitted provided that the following conditions are met:
+
+// 1. Redistributions of source code must retain the above copyright notice, this
+//    list of conditions and the following disclaimer.
+// 2. Redistributions in binary form must reproduce the above copyright notice,
+//    this list of conditions and the following disclaimer in the documentation
+//    and/or other materials provided with the distribution.
+
+// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
+// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+// DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
+// ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+// LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+// ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+// The views and conclusions contained in the software and documentation are those
+// of the authors and should not be interpreted as representing official policies,
+// either expressed or implied, of the FreeBSD Project.
+
+//------------------------------------------------------------------------------
+
+#include "LocalAcceptor.h"
+
+//------------------------------------------------------------------------------
+
+using xplcommon::win32::LocalAcceptor;
+
+//------------------------------------------------------------------------------
+
+LocalAcceptor::LocalAcceptor(LocalServerSocketBase* socket, const char* name) :
+    Completer(socket),
+    socket(*socket),
+    accepted(false)
+{
+    LocalSocket::setupName(this->name, name);
+}
+
+//------------------------------------------------------------------------------
+
+bool LocalAcceptor::accept()
+{
+    if (accepted) return true;
+
+    if (isWaited()) {
+        DWORD size = 0;
+        if (getResult(size, socket.handle)) {
+            removeFromWaiter();
+            accepted = true;
+            return true;
+        } else {
+            if (socket.failed()) {
+                removeFromWaiter();
+            }
+            return false;
+        }
+    }
+
+
+    if (!socket.createNamedPipe(name)) {
+        return false;
+    }
+
+    bool result = socket.connectNamedPipe(overlapped);
+    if (result) {
+        accepted = true;
+    } else if (!socket.failed()) {
+        addTo(socket.waiter);
+    }
+
+    return result;
+}
+
+//------------------------------------------------------------------------------
+
+// Local Variables:
+// mode: C++
+// c-basic-offset: 4
+// indent-tabs-mode: nil
+// End:
Index: src/xplcommon/win32/LocalAcceptor.h
===================================================================
--- src/xplcommon/win32/LocalAcceptor.h	(revision 21)
+++ src/xplcommon/win32/LocalAcceptor.h	(revision 21)
@@ -0,0 +1,168 @@
+// Copyright (c) 2012 by István Váradi
+
+// This file is part of libxplcommon, a common utility library for
+// development related to X-Plane
+
+// Redistribution and use in source and binary forms, with or without
+// modification, are permitted provided that the following conditions are met:
+
+// 1. Redistributions of source code must retain the above copyright notice, this
+//    list of conditions and the following disclaimer.
+// 2. Redistributions in binary form must reproduce the above copyright notice,
+//    this list of conditions and the following disclaimer in the documentation
+//    and/or other materials provided with the distribution.
+
+// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
+// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+// DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
+// ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+// LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+// ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+// The views and conclusions contained in the software and documentation are those
+// of the authors and should not be interpreted as representing official policies,
+// either expressed or implied, of the FreeBSD Project.
+
+#ifndef XPLCOMMON_WIN32_LOCALACCEPTOR_H
+#define XPLCOMMON_WIN32_LOCALACCEPTOR_H
+//------------------------------------------------------------------------------
+
+#include "Completer.h"
+
+#include "LocalServerSocketBase.h"
+#include "LocalSocket.h"
+
+//------------------------------------------------------------------------------
+
+namespace xplcommon { namespace win32 {
+
+//------------------------------------------------------------------------------
+
+/**
+ * Instances of this class are used to accept connection requests to a
+ * local server socket, i.e. named pipe.
+ */
+class LocalAcceptor : public Completer,
+                      public FailableReference<LocalAcceptor>
+{
+private:
+    /**
+     * The local server socket for which we are accepting connections.
+     */
+    LocalServerSocketBase& socket;
+
+    /**
+     * The name of the pipe to accept.
+     */
+    char name[256];
+
+    /**
+     * Indicate if the connection has been accepted.
+     */
+    bool accepted;
+
+protected:
+    /**
+     * Construct the acceptor.
+     */
+    LocalAcceptor(LocalServerSocketBase* socket, const char* name);
+
+public:
+    /**
+     * Try to accept a connection.
+     *
+     * If one is already accepted, but not retrieved yet, return true.
+     *
+     * If a new connection becomes immediately available, return true.
+     *
+     * If a new connection is not yet available, returns false.
+     *
+     * If some error occurs, the acceptor is marked failed and false
+     * is returned.
+     */
+    bool accept();
+
+    /**
+     * Get the local socket accepted last. If no socket was accepted,
+     * return 0. The local socket's waiter will be the given one.
+     */
+    LocalSocket* getSocket(Waiter* waiter,
+                           size_t readingCapacity = LocalSocket::DEFAULT_CAPACITY,
+                           size_t writingCapacity = LocalSocket::DEFAULT_CAPACITY);
+    /**
+     * Get the local socket accepted last. If no socket was accepted,
+     * return 0. The local socket's waiter will be the same as that of
+     * the associated server socket.
+     */
+    LocalSocket* getSocket(size_t readingCapacity = LocalSocket::DEFAULT_CAPACITY,
+                           size_t writingCapacity = LocalSocket::DEFAULT_CAPACITY);
+
+
+private:
+    /**
+     * Get the failable object.
+     */
+    const ::xplcommon::Failable& getFailable() const;
+
+    /**
+     * Get the failable object.
+     */
+    ::xplcommon::Failable& getFailable();
+
+    friend class FailableReference<LocalAcceptor>;
+    friend class LocalServerSocket;
+};
+
+//------------------------------------------------------------------------------
+// Inline definitions
+//------------------------------------------------------------------------------
+
+inline LocalSocket* LocalAcceptor::getSocket(Waiter* waiter,
+                                             size_t readingCapacity,
+                                             size_t writingCapacity)
+{
+    if (!accepted) return 0;
+
+    LocalSocket* s= new LocalSocket(waiter, socket.releaseHandle(),
+                                    readingCapacity, writingCapacity);
+    accepted = false;
+    return s;
+}
+//------------------------------------------------------------------------------
+
+inline LocalSocket* LocalAcceptor::getSocket(size_t readingCapacity,
+                                             size_t writingCapacity)
+{
+    return getSocket(socket.waiter, readingCapacity, writingCapacity);
+}
+
+//------------------------------------------------------------------------------
+
+inline const ::xplcommon::Failable& LocalAcceptor::getFailable() const
+{
+    return socket;
+}
+
+//------------------------------------------------------------------------------
+
+inline ::xplcommon::Failable& LocalAcceptor::getFailable()
+{
+    return socket;
+}
+
+//------------------------------------------------------------------------------
+
+} /* namespace xplcommon::win32 */ } /* namespace xplcommon */
+
+//------------------------------------------------------------------------------
+#endif // XPLCOMMON_WIN32_LOCALACCEPTOR_H
+
+// Local Variables:
+// mode: C++
+// c-basic-offset: 4
+// indent-tabs-mode: nil
+// End:
Index: src/xplcommon/win32/LocalClientSocket.cc
===================================================================
--- src/xplcommon/win32/LocalClientSocket.cc	(revision 21)
+++ src/xplcommon/win32/LocalClientSocket.cc	(revision 21)
@@ -0,0 +1,56 @@
+// Copyright (c) 2012 by István Váradi
+
+// This file is part of libxplcommon, a common utility library for
+// development related to X-Plane
+
+// Redistribution and use in source and binary forms, with or without
+// modification, are permitted provided that the following conditions are met:
+
+// 1. Redistributions of source code must retain the above copyright notice, this
+//    list of conditions and the following disclaimer.
+// 2. Redistributions in binary form must reproduce the above copyright notice,
+//    this list of conditions and the following disclaimer in the documentation
+//    and/or other materials provided with the distribution.
+
+// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
+// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+// DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
+// ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+// LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+// ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+// The views and conclusions contained in the software and documentation are those
+// of the authors and should not be interpreted as representing official policies,
+// either expressed or implied, of the FreeBSD Project.
+
+//------------------------------------------------------------------------------
+
+#include "LocalClientSocket.h"
+
+//------------------------------------------------------------------------------
+
+using xplcommon::win32::LocalClientSocket;
+
+//------------------------------------------------------------------------------
+
+HANDLE LocalClientSocket::create(const char* name, bool overlapped)
+{
+    char buf[256];
+    setupName(buf, name);
+
+    return CreateFile(buf, GENERIC_READ|GENERIC_WRITE,
+                      0, 0, OPEN_EXISTING,
+                      FILE_FLAG_NO_BUFFERING | FILE_FLAG_OVERLAPPED, 0);
+}
+
+//------------------------------------------------------------------------------
+
+// Local Variables:
+// mode: C++
+// c-basic-offset: 4
+// indent-tabs-mode: nil
+// End:
